#! /bin/sh

# Please keep these in alphanumeric sequence  -- Max 2001/04/11
system=`uname -s``uname -r`
case $system in
	BSD*)
		system=bsd
		;;
	FreeBSD*)
		system=freebsd
		;;
	HP-UX*)
		system=hpux
		;;
	IRIX64*)
		system=irix64
        	;;
	IRIX*)
		system=irix
        	;;
	Linux*)
		system=linux
		;;
	NetBSD*)
		system=netbsd
		;;
	*NT*)
		system=nt
		;;
	OSF1*)
		system=osf1
		;;
	SunOS4*)
		system=sunOS
		;;
	SunOS5*)
		system=solaris
		;;
	*)
		echo "Unknown system \"$system\"."
		exit 1
		;;		
esac

machine=`uname -m`
case $machine in
	9000/*)
		machine=hp
		;;
	alpha)
		machine=dec
		;;
	i[3456]86 | i86pc)
		machine=intel
		;;
	ia64)
		machine=itanium
		;;
	IP*)
		machine=sgi
		;;
	ppc)
		machine=ppc
		;;
	sparc*)
		machine=sparc
		;;
	sun4*)
		machine=sparc
		;;
	*)
		echo "Unknown machine \"$machine\"."
		exit 1
		;;		
esac	
 
#if test x`hostname` = xkitty
#then
#	machine=hp
#	system=dino
#fi
#
#if test x`hostname` = xmerlin
#then
#	machine=hp
#	system=pci
#fi
#
#if test x`hostname` = xpluto
#then
#	machine=hp
#	system=pci
#fi

echo "$machine"_"$system"
exit 0
