/*
dx.c
example m3_Description program
compiles just like "description", so modify the m3-dist/makefile by copy-and-pasting the lines about "description" for the dx target.
Or just compile it like this:

gcc  -g -O2  -DINSIST -DGCC -Dm3_intel_linux  -I/ufs/arpa/finucane/gm/mt/libmt -I/ufs/arpa/finucane/gm/mt/ping -I/ufs/arpa/finucane/gm/mt/deadlock -I/ufs/arpa/finucane/gm/include -x c++ -c -g -o intel_linux/dx.o dx.c
gcc  -o intel_linux/dx intel_linux/dx.o intel_linux/libhostgm.a /ufs/arpa/finucane/gm/mt/libmt/intel_linux/libmt.a -lm

*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "m3_Description.h"

static void printLine (char*s)
{
  printf ("%s\n", s);
}

static void usage ()
{
  printf ("usage: dx switchname\n");
  exit (1);
}


static void printXbar (FILE*fp, m3_DescriptionXbar*xbar)
{
  char sb [61];

  fprintf (fp, "xbar %d\n", xbar->index);

  for (int i = 0; i < 16; i++)
  {
    xbar->ports [i].print (fp);
    fprintf (fp, "goodCrcs %s\n", sb,xbar->ports [i].string64 (sb,xbar->ports [i].goodCrcs [1]));
  }
}

int main (int argc, char**argv)
{
  mt_Component::initialize (printLine);
  m3_Component::initialize (printLine);
  m3_WebClient web;
  m3_Description d;
  char*switchname = argv [1];
  int i;
  
  if (argc != 2)
    usage ();
  
  if (!d.examine (&web, switchname))
  {
    printf ("failed\n");
    usage ();
  }

  for (i = 0; i < M3_MAX_LINE_CARD; i++)
    if (d.linecards [i].type && d.linecards [i].xbar.type)
      printXbar (stdout, &d.linecards [i].xbar);
  
  for (int i = 0; i < d.numBackplaneXbars; i++)
    printXbar (stdout, &d.backplaneXbars [i]);
  
  return 0;
}
