/*
  fake_web.c
  evil m2 kludge
  finucane@myri.com (David Finucane)
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "m3_TestClient.h"
#include "m3_defines.h"

m3_int64 good [16*16];
m3_int64 bad [16*16];

static void printBigUc (FILE*fp, char*ipAddress, char*ethernetAddress, int numXbars)
{
  fprintf (fp, "Slot 56 (big uc)\n");
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "lostCommunicationCount 0\n");
  fprintf (fp, "reestablishCommunicationCount 0\n");
  fprintf (fp, "changeCount 0\n");
  fprintf (fp, "slotState 22\n");
  fprintf (fp, "Uc %d\n", numXbars == 1 ? 3 : 16 + numXbars + 1 );
  fprintf (fp, "state 4\n");
  fprintf (fp, "overTemperatureCount 0\n");
  fprintf (fp, "resetCount 0\n");
  fprintf (fp, "firmwareFaultCount 0\n");
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "engineeringDateCode\n");
  fprintf (fp, "firmwareVersion M3 Switch Firmware v0.99 Type: BIG UC Compiled on: Jul 30 2001 14:53:36\n");
  fprintf (fp, "monitorFirmwareVersion M3-M Monitor v1.0Last compiled on: Jan 18 2001 10:04:46\n");
  fprintf (fp, "scratchPad 0\n");
  fprintf (fp, "reboot 0\n");
  fprintf (fp, "monitorCause 0\n");
  fprintf (fp, "firstCoreDumpID 0\n");
  fprintf (fp, "lastCoreDumpID 0\n");
  fprintf (fp, "Linecard %d\n", numXbars == 1 ? 3 : 17);
  fprintf (fp, "BigUc 1\n");
  fprintf (fp, "backplaneType %d\n", numXbars == 1 ? 2 : 16);
  fprintf (fp, "versionForBigUc release-0.9.9.6 Oct 16 2001 15:00:28\n");
  fprintf (fp, "ethernetAddress %s\n", ethernetAddress);
  fprintf (fp, "ipAddress %s\n", ipAddress);
}

static void printFiberPort (FILE*fp, int slot, int i)
{
  fprintf (fp, "ShortwaveFiberPort %d\n", slot * 8 + i);
  fprintf (fp, "portNumber %d\n", i);
  fprintf (fp, "overrunsForShortwaveFiberPort 0\n");
  fprintf (fp, "sanFaultForShortwaveFiberPort 0\n");
  fprintf (fp, "sanFaultCountForShortwaveFiberPort 0\n");
  fprintf (fp, "serdesFaultForShortwaveFiberPort 0\n");
  fprintf (fp, "serdesFaultCountForShortwaveFiberPort 0\n");
  fprintf (fp, "notInSyncForShortwaveFiberPort 0\n");
  fprintf (fp, "notInSyncCountForShortwaveFiberPort 0\n");
  fprintf (fp, "signalLost 0\n");
  fprintf (fp, "signalLostCount 0\n");
  fprintf (fp, "selfTestResultForShortwaveFiberPort 0\n");
  fprintf (fp, "controlForShortwaveFiberPort 0\n");
}


static void printSpine (FILE*fp, int slot)
{
  fprintf (fp, "Slot %d (lc8f)\n", slot);
  fprintf (fp, "serialNumber 68319 M3-SPINE-8F\n");
  fprintf (fp, "lostCommunicationCount 0\n");
  fprintf (fp, "reestablishCommunicationCount 0\n");
  fprintf (fp, "changeCount 0\n");
  fprintf (fp, "slotState 57\n");
  fprintf (fp, "Uc %d\n", slot);
  fprintf (fp, "state 4\n");
  fprintf (fp, "overTemperatureCount 0\n");
  fprintf (fp, "resetCount 0\n");
  fprintf (fp, "firmwareFaultCount 0\n");
  fprintf (fp, "serialNumber 68319 M3-SPINE-8F\n");
  fprintf (fp, "engineeringDateCode 0046 0102\n");
  fprintf (fp, "firmwareVersion M3 Switch Firmware v0.99\n");
  fprintf (fp, "Type: LC8F Compiled on: Apr 19 2001 15:12:23\n");
  fprintf (fp, "monitorFirmwareVersion M3 Monitor v1.0 Last compiled on: Jan 18 2001 10:04:36\n");
  fprintf (fp, "scratchPad 0\n");
  fprintf (fp, "reboot 0\n");
  fprintf (fp, "monitorCause 0\n");
  fprintf (fp, "firstCoreDumpID 0\n");
  fprintf (fp, "lastCoreDumpID 0\n");
  fprintf (fp, "Linecard %d\n", slot);
  fprintf (fp, "voltageAForLinecard 232\n");
  fprintf (fp, "voltageBForLinecard 231\n");
  fprintf (fp, "shutdownForLinecard 0\n");

  for (int i = 0; i < 8; i++)
    printFiberPort (fp, slot, i);
}

static void printXbarPort (FILE*fp, int xbar, int i, m3_int64*good, m3_int64*bad, int offset)
{
  fprintf (fp, "XbarPort %d\n",  i + 1 + (xbar - 1) * 16);
  fprintf (fp, "portNumber i\n");
  fprintf (fp, "selfTestResultForXbarPort 0\n");
  fprintf (fp, "invalidRoutes 0\n");
  fprintf (fp, "illegalSymbols 0\n");
  fprintf (fp, "missedBeats 0\n");
  fprintf (fp, "deadPorts 0\n");
  fprintf (fp, "goodCrcs %d\n", good [offset + i].low);
  fprintf (fp, "badCrcs %d\n", bad [offset + i].low);
  fprintf (fp, "dataIn 0\n");
  fprintf (fp, "dataOut 0\n");
  fprintf (fp, "portDownOnIllegalSymbol 0\n");
  fprintf (fp, "portDownOnIllegalSymbolCount 0\n");
  fprintf (fp, "portDownOnMissedBeat 0\n");
  fprintf (fp, "portDownOnMissedBeatCount 0\n");
  fprintf (fp, "portDown 0\n");
  fprintf (fp, "portUpCount 0\n");
  fprintf (fp, "receiveTimeout 0\n");
  fprintf (fp, "receiveTimeoutCount 0\n");
  fprintf (fp, "transmitTimeout 0\n");
  fprintf (fp, "transmitTimeoutCount 0\n");
  fprintf (fp, "controlForXbarPort 0\n");
}


static void printLinecard (FILE*fp, int slot, int xbar, m3_int64*good, m3_int64*bad, int offset)
{
  fprintf (fp, "Slot %d (lc8fx)\n", slot);
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "lostCommunicationCount 0\n");
  fprintf (fp, "reestablishCommunicationCount 0\n");
  fprintf (fp, "changeCount 0\n");
  fprintf (fp, "slotState 300\n");
  fprintf (fp, "Uc %d\n", slot);
  fprintf (fp, "state 4\n");
  fprintf (fp, "overTemperatureCount 0\n");
  fprintf (fp, "resetCount 28\n");
  fprintf (fp, "firmwareFaultCount 0\n");
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "engineeringDateCode\n");
  fprintf (fp, "firmwareVersion M3 Switch Firmware v0.95 Type: LC8FX Compiled on: Mar 19 2001 10:41:55\n");
  fprintf (fp, "monitorFirmwareVersion M3\n");
  fprintf (fp, "Monitor v1.0 Last compiled on: Jan 18 2001 10:04:36\n");
  fprintf (fp, "scratchPad 0\n");
  fprintf (fp, "reboot 0\n");
  fprintf (fp, "monitorCause 1\n");
  fprintf (fp, "firstCoreDumpID 0\n");
  fprintf (fp, "lastCoreDumpID 0\n");
  fprintf (fp, "Linecard 1\n");
  fprintf (fp, "voltageAForLinecard 233\n");
  fprintf (fp, "voltageBForLinecard 233\n");
  fprintf (fp, "shutdownForLinecard 0\n");
  fprintf (fp, "Xbar16 1\n");
  fprintf (fp, "firstXbarPort %d\n", 1 + (xbar - 1) * 16);
  fprintf (fp, "lastXbarPort %d\n", 1 + (xbar - 1) * 16 + 16);
  fprintf (fp, "timeoutForXbar16 63\n");
  fprintf (fp, "selfTestResultForXbar16 0\n");

  for (int i = 0; i < 16; i++)
    printXbarPort (fp, xbar, i, good, bad, offset);

  for (int i = 0; i < 8; i++)
    printFiberPort (fp, slot, i);
}


static void printBackplane (FILE*fp, int slot, int xbar, int uc, m3_int64*good, m3_int64*bad, int offset)
{
  fprintf (fp, "Slot 33 (backplane master)\n");
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "lostCommunicationCount 1\n");
  fprintf (fp, "reestablishCommunicationCount 1\n");
  fprintf (fp, "changeCount 0\n");
  fprintf (fp, "slotState 263\n");
  fprintf (fp, "Uc %d\n", uc);
  fprintf (fp, "state 4\n");
  fprintf (fp, "overTemperatureCount 0\n");
  fprintf (fp, "resetCount 0\n");
  fprintf (fp, "firmwareFaultCount 0\n");
  fprintf (fp, "serialNumber\n");
  fprintf (fp, "engineeringDateCode\n");
  fprintf (fp, "firmwareVersion M3 Switch Firmware v0.95 Type: BACKPLANE MASTER Compiled on: Mar 19 2001 14:38:38\n");
  fprintf (fp, "monitorFirmwareVersion M3 Monitor v1.0 Last compiled on: Jan 18 2001 10:04:36\n");
  fprintf (fp, "scratchPad 0\n");
  fprintf (fp, "reboot 0\n");
  fprintf (fp, "monitorCause 0\n");
  fprintf (fp, "firstCoreDumpID 0\n");
  fprintf (fp, "lastCoreDumpID 0\n");

  fprintf (fp, "Backplane %d\n", slot - 33 + 1);
  fprintf (fp, "shutdownForBackplane 0\n");
  fprintf (fp, "BackplaneMaster %d\n", slot - 33 + 1);
  fprintf (fp, "voltageAForBackplaneMaster 229\n");
  fprintf (fp, "voltageBForBackplaneMaster 230\n");
  fprintf (fp, "shutdownForBackplaneMaster 0\n");
  fprintf (fp, "backplaneStatus 4\n");

  fprintf (fp, "Xbar16 %d\n", xbar);
  fprintf (fp, "firstXbarPort %d\n", 1 + (xbar - 1) * 16);
  fprintf (fp, "lastXbarPort %d\n", 1 + (xbar - 1) * 16 + 16);
  fprintf (fp, "timeoutForXbar16 63\n");
  fprintf (fp, "selfTestResultForXbar16 0\n");

  for (int i = 0; i < 16; i++)
    printXbarPort (fp, xbar, i, good, bad, offset);
}


static void printSwitch (FILE*fp, char*ipAddress, char*ethernetAddress, m3_int64*good, m3_int64*bad, int numXbars)
{
  int backplaneType = numXbars == 1 ? 2 : 16;
  
  for (int i = 0; i < backplaneType / 2; i++)
    printSpine (fp, 1 + i);
  
  for (int i = 0; i < backplaneType / 2; i++)
    printLinecard (fp, i + 1 + backplaneType / 2, i + 1, good, bad, i * 16);  

  if (backplaneType == 16)
  {
    for (int i = 0; i < backplaneType / 2; i++)
      printBackplane (fp, 33 + i, i + 1 + backplaneType / 2, backplaneType + 1, good, bad, (i + backplaneType / 2) * 16);
  }
  
  printBigUc (fp, ipAddress, ethernetAddress, numXbars);
}

static void printLine (char*s)
{
  printf ("%s\n", s);
}

static void usage ()
{
  printf ("usage: fake_web <m2-ip-address> <m2-ethernet address>\n");
  exit (1);
}

int main (int argc, char**argv)
{
  m3_Component::initialize (printLine);
  m3_TestClient client;
  
  char*s;
  int numPorts;
  
  if (argc != 3)
    usage ();

  if (!client.open (argv [1]) || !(numPorts = client.m2_getPacketCounters (good, bad)))
    return 1;

  printSwitch (stdout, argv [1], argv [2], good, bad, numPorts / 16);
  
  return 0;
}

