/*
  find_switches.c
  program to find m3 switches on an ethernet
  finucane@myri.com (David Finucane)
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <time.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>

#include "m3_RollcallClient.h"
#include "m3_defines.h"

static void printLine (char*s)
{
  printf ("%s\n", s);
}

static m3_RollcallClient*client = 0;

static void usage ()
{
  printf ("usage: find_switches\n");
  exit (1);
}

int main (int argc, char**argv)
{
  int*switches = 0;
  m3_Component::initialize (printLine);
  m3_RollcallClient client;
  
  if (argc != 1)
    usage (); 
  
  if (!client.open ())
  {
    printf ("open failed\n");
    return 1;
  }
  
  int numSwitches = client.findAddresses (&switches);
  printf ("found %d switches\n", numSwitches);

  for (int i = 0; switches && i < numSwitches; i++)
  {
    printf ("%d.%d.%d.%d\n",
	    (unsigned) (((char*)(&switches [i])) [0] & 0xff),
	    (unsigned) (((char*)(&switches [i])) [1] & 0xff),
	    (unsigned) (((char*)(&switches [i])) [2] & 0xff),
	    (unsigned) (((char*)(&switches [i])) [3] & 0xff));
  }
  client.close ();
  return 0;
}
