/*
   hex2uc.c
   host program to program a m3 microcontroller's flash memory
   over the ethernet.

   finucane@myri.com (David Finucane)
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <signal.h>

#include "m3_Hex2Uc.h"

static char *usage = "hex2uc <host> <serial_port> <filename>";

static void printLine (char*s)
{
  printf ("%s\n", s);
}

int main (int argc, char *argv[])
{
  m3_Component::initialize (printLine);
  m3_Hex2Uc hex2uc;
  int port;
  char*hostarg = argv [1];
  char*portarg = argv [2];
  char*filearg = argv [3];
  
#ifdef USE_SIG_HOLD
  sighold (SIGPIPE);
#else
  sigblock (sigmask (SIGPIPE));
#endif

  if (argc < 4)
  {
    printf ("usage: %s \n", usage);
    return 1;
  }
  port = atoi (portarg);
  if (port < 0 || port > M3_MAX_SERIAL_PORT)
  {
    printf ("bad port number %s\n", portarg);
    printf ("usage: %s \n", usage);
    return 1;
  }
  if (!hex2uc.program (hostarg, filearg, port))
    printf ("usage: %s \n", usage);
}
