/*
  m3_Component.c
  map tools
  finucane@myri.com (David Finucane)
*/


#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <stdlib.h>

#include "m3_Component.h"
#include "insist.h"

static m3_PrintLineFunction printLineFunction;

void m3_Component::initialize (m3_PrintLineFunction function)
{
  if (!function)
  {
    printf ("m3_Component::initialize: programer error. no printLineFunction\n");
  }
  printLineFunction = function;
}

int m3_Component::validComponent () const
{
  if (created != CREATED)
  {
    printInsist ("m3_Component::validComponent: programmer error. using uncreated object.");
  }
  
  if (destroyed)
  {
    printInsist ("m3_Component::validComponent: programmer error. using destroyed object.");
  }
  return 1;
}

m3_Component::~m3_Component()
{
  validComponent ();
  destroyed++;
}

m3_Component::m3_Component ()
{
  destroyed = 0;
  created = CREATED;
  
  if (!printLineFunction)
    printf ("Programmer error.\n" "m3_Component::initialize() not called.\n");
}


void m3_Component::printFormat (const char*fmt,...)
{
  if (!fmt || !printLineFunction)
    return;
  
  static char buffer [MAX_PRINTLINE];
  char*s = buffer;
  
  va_list args;
  va_start (args, fmt);
  vsprintf (s, fmt, args);
  va_end (args);
  
  (*printLineFunction) (buffer);
}

void m3_Component::printInsist (const char*fmt,...)
{
  if (!fmt || !printLineFunction)
    return;
  
  static char buffer [MAX_PRINTLINE];
  char*s = buffer;
  
  va_list args;
  va_start (args, fmt);
  vsprintf (s, fmt, args);
  va_end (args);
  
  (*printLineFunction) (buffer);
}
