/*
  m3_Component.h
  map tools
  finucane@myri.com (David Finucane)
*/

#ifndef m3_Component_h
#define m3_Component_h

#ifdef M3_VXWORKS
#include <vxWorks.h>
#endif

#include <stdarg.h>

typedef void (*m3_PrintLineFunction) (char*s);

class m3_Component
{
  private:
  enum
  {
    MAX_PRINTLINE = 2000,
    CREATED = 0x12345678
  };
  int destroyed;
  int created;
  
  public:
  m3_Component ();
  virtual ~m3_Component ();
  int validComponent () const;
  static void initialize (m3_PrintLineFunction function);
  static void printFormat (const char*fmt, ...);
  static void printInsist (const char*fmt, ...);
};


#endif /*m3_Component_h*/


