#ifndef m3_hex2flash_h
#define m3_hex2flash_h
/*
   m3_Hex2Uc.h
   class to program m3 firmwaree
   over the ethernet.

   finucane@myri.com (David Finucane)
*/

#include "m3_Component.h"
#include "m3_defines.h"
#include <stdio.h>

class m3_Hex2Flash : public m3_Component
{  
  public:
  enum
  {
    MAX_TERMINAL_MESSAGE_LENGTH = 10000
  };
  
  private:
  char terminal_buffer [MAX_TERMINAL_MESSAGE_LENGTH];

  int hex_size (FILE * fp);
  char*hex_image (FILE * fp, int size, unsigned *start);
  int hex_open (char *hostname, int port);
  int epilogue (int fd);

  int verbose;
  
  public:
  m3_Hex2Flash (int verbose=1);
  int program (char*hostname, char*filename, int variable, char ethernet [6], char ip [4], char netmask [4], int extended_count, int*extended_values);
  int getImage (char*filename, char**image, unsigned*start);
  int getVersionString (char*image, int size, char*versionString);
  int program (char*image, int size, unsigned start, char*hostname, int variable, char ethernet [6], char ip [4], char netmask [4], int extended_count, int*extended_values);
};

#endif
