#ifndef m3_hex2uc_h
#define m3_hex2uc_h
/*
   m3_Hex2Uc.h
   class to  program a m3 microcontroller's flash memory
   over the ethernet.

   finucane@myri.com (David Finucane)
*/

#include "m3_Component.h"
#include "m3_defines.h"
#include <stdio.h>

class m3_Hex2Uc : public m3_Component
{  
  private:
  int check_buf (char*buf);
  int read_s19 (FILE*f, char*buf);
  int port_connect (char *hostname, int port);
  int epilogue (int fd);
  char image [M3_UC_FLASH_MAX_IMAGE * 2];
  int verbose;
  
  public:
  m3_Hex2Uc (int verbose=1);
  int program (char*hostname, char*filename, int port);
  int getFirmwareVersion (char*filename, char*firmwareVersion);
};
#endif
