#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "insist.h"
#include "m3_SwitchFile.h"

#define M3_SWITCH_FILE_FORMAT "%d.%d.%d.%d"

m3_SwitchFile::m3_SwitchFile ()
{
  addresses = 0;
  numAddresses = 0;
}
m3_SwitchFile::~m3_SwitchFile ()
{
  if (addresses) free (addresses);
}

#define M3_SWITCH_MAX_LINE 260

int m3_SwitchFile::read (char*filename, int*addresses)
{
  FILE*fp;
  int fat [4];
  char address [4];
  char line [M3_SWITCH_MAX_LINE + 1];
  char*s;
  
  insist (this && filename);
  
  numAddresses = 0;
  
  fp = fopen (filename, "r");

  if (fp <= 0)
  {
    printFormat ("couldn't open %s", filename);
    return 0;
  }
  
  while (s = fgets (line, M3_SWITCH_MAX_LINE, fp))
  {
    if (4 == sscanf (s, M3_SWITCH_FILE_FORMAT, &fat [0], &fat [1], &fat [2], &fat [3]))
    {
      if (addresses)
      {
	for (int i = 0; i < 4; i++)
	  address [i] = fat [i];
	memcpy (&addresses [numAddresses], address, 4);
      }
      numAddresses++;
    }
  }

  fclose (fp);
  return numAddresses;
  exception: return 0;
}

int m3_SwitchFile::write (char*filename, int numAddresses, int*addresses)
{
  FILE*fp;  
  insist (this && filename && numAddresses && addresses);

  fp = fopen (filename, "w+");
  insist (fp);
  
  for (int i = 0; i < numAddresses; i++)
  {
    fprintf (fp, M3_SWITCH_FILE_FORMAT "\n", 
	     (unsigned) (((char*)(&addresses [i])) [0] & 0xff),
	     (unsigned) (((char*)(&addresses [i])) [1] & 0xff),
	     (unsigned) (((char*)(&addresses [i])) [2] & 0xff),
	     (unsigned) (((char*)(&addresses [i])) [3] & 0xff));
    
  }
  fclose (fp);
  return 1;
  exception: return 0;
}

int m3_SwitchFile::fromFile (char*filename, int**addresses)
{
  insist (this && filename && addresses);

  if (this->addresses)
  {
    free (this->addresses);
    this->addresses = 0;
  }

  numAddresses = read (filename, 0);
  insist (numAddresses > 0);

  this->addresses = *addresses = (int*) malloc (sizeof (int) * numAddresses);
  insist (this->addresses);
  
  return read (filename, this->addresses);
  
  exception: return 0;
}
