/*
  m3_XbarFinder.h
  finucane@myri.com
*/

#ifndef m3_XbarFinder_h
#define m3_XbarFinder_h

#include "mt_Job.h"
#include "mt_Route.h"

#include "m3_Component.h"
#include "m3_TestClient.h"
#include "m3_RollcallClient.h"

class m3_XbarFinder : public m3_Component
{
  private:
  int fd;
  int port;
  char address [4];
  
  m3_RollcallClient rollcall;
  m3_TestClient test;
  int open ();
  int receive (int usecs, char ethernetAddress [6], int*xbar);
  int send (mt_Job*job, mt_Route*route, int usecs);
  
  public:
  m3_XbarFinder ();
  ~m3_XbarFinder ();
  int close ();
  int getPort ()
  {
    return port;
  }
  int setNotify ();
  int setNotify (int*addresses, int numAddresses);
  int setNotify (char**addresses, int numAddresses);
  int find (mt_Job*job, mt_Route*route, char ipAddress [4], char ethernetAddress [6], int*xbar, int sendUsecs, int receiveUsecs);
};


#endif /*m3_XbarFinder_h*/
