#ifndef m3_XbarTable_h
#define m3_XbarTable_h

#include "m3_Component.h"

#include "mt_Job.h"
#include "mt_Graph.h"
#include "mt_Node.h"
#include "m3_XbarFinder.h"

class m3_XbarTableEntry
{
  public:
  mt_Node*node;
  char ipAddress [4];
  char ethernetAddress [6];
  int xbar;
  int correction;
  m3_XbarTableEntry ();
};

class m3_XbarTable : m3_Component
{
  private:
  m3_XbarFinder finder;
  int numEntries;
  m3_XbarTableEntry*entries;
  int find (mt_Job*job, mt_Graph*g);
  
  public:
  m3_XbarTable (int numNodes);
  ~m3_XbarTable ();
  int fromFile (mt_Node*root, mt_Graph*g, char*filename);
  int toFile (char*filename);
  int fromNetwork (mt_Job*job, mt_Graph*g, int*addresses, int numAddresses);
  int equals (m3_XbarTable*table);
  m3_XbarTableEntry*lookup (char ethernetAddress [6], int xbar);
  m3_XbarTableEntry*lookup (mt_Node*node);
};


#endif /*m3_XbarTable_h*/




