#ifndef m3_defines_h
#define m3_defines_h

extern int m3_hp;
extern int m3_crippled;

#define M3_FLASH_PORT 4001
#define M3_TEST_PORT 4002
#define M3_UC_FLASH_PORT 4003
#define M3_ROLLCALL_PORT 4004

#define M3_FLASH_STRING "two tons of tiny tuna teeth"
#define M3_FLASH_BASE 0xffe00000
#define M3_FLASH_ETHERNET_BASE 0xfff00000
#define M3_FLASH_IP_BASE 0xfff00008
#define M3_FLASH_NETMASK_BASE 0xfff00010
#define M3_FLASH_PERMANENT_START 0xfff00100
#define M3_FLASH_EXTENDED_COUNT  0xfff00018
#define M3_FLASH_EXTENDED_BASE   0xfff0001c
#define M3_FLASH_MAX_EXTENDED ((M3_FLASH_PERMANENT_START - M3_FLASH_EXTENDED_BASE) / 4)
#define M3_FLASH_EXTENDED_ADDRESS(n) ((int*)(M3_FLASH_EXTENDED_BASE + n * 4))
#define M3_FLASH_EXTENDED_VALUE(n) (*(int*)(M3_FLASH_EXTENDED_BASE + n * 4))

#define M3_FLASH_MAX_IMAGE (1024*1024 - 256*256)
#define M3_FLASH_MAX_ERRORS 2

#define M3_FLASH_SAN_BITS_WORD 0
#define M3_FLASH_PRODUCT_TYPE_WORD 1

#define M3_FLASH_VARIABLE 0
#define M3_FLASH_PERMANENT 1
#define M3_FLASH_EXTENDED 2

#define M3_UC_FLASH_STRING "y sostengo que no hay pecado, sino ignorancia."
#define M3_UC_FLASH_MAX_IMAGE (1024 * 64)

#define M3_TEST_MTU 8192
#define M3_TEST_STRING "Tamburlaine, the scourge of God must die."

#define M3_MAX_UC 64
#define M3_MAX_LINE_CARD 16
#define M3_MAX_LINE_CARD_PORT 8
#define M3_MAX_BACKPLANE 8
#define M3_MAX_BACKPLANE_MASTER 2
#define M3_MAX_FAN 16
#define M3_MAX_POWER_SUPPLY 2
#define M3_MAX_BACKPLANE_XBAR 8
#define M3_MAX_XBAR16 (M3_MAX_BACKPLANE_XBAR + M3_MAX_LINE_CARD)
#define M3_MAX_XBAR_PORT (M3_MAX_XBAR16 * 16)
#define M3_MAX_SAN_PORT (M3_MAX_LINE_CARD_PORT * M3_MAX_LINE_CARD)
#define M3_MAX_LAN_PORT (M3_MAX_LINE_CARD_PORT * M3_MAX_LINE_CARD)
#define M3_MAX_HSSDC_PORT (M3_MAX_LINE_CARD_PORT * M3_MAX_LINE_CARD)
#define M3_MAX_SHORTWAVE_FIBER_PORT (M3_MAX_LINE_CARD_PORT * M3_MAX_LINE_CARD)
#define M3_MAX_BIG_UC 1
#define M3_MAX_VOLTAGE (M3_MAX_UC * 16)
#define M3_MAX_TEMPERATURE (M3_MAX_UC * 2)
#define M3_MAX_OPERATING_LED (M3_MAX_UC * 2)
#define M3_MAX_CORE_DUMP 2
#define M3_MAX_SLOT 64
#define M3_MAX_CURRENT M3_MAX_UC
#define M3_MAX_GE_PORT (M3_MAX_LINE_CARD_PORT * M3_MAX_LINE_CARD)

#define M3_MAX_SERIAL_PORT 64

#define M3_MAX_PART (M3_MAX_LINE_CARD + M3_MAX_BACKPLANE + M3_MAX_BACKPLANE_MASTER + M3_MAX_FAN + M3_MAX_POWER_SUPPLY + M3_MAX_XBAR16 + M3_MAX_XBAR_PORT +  M3_MAX_SAN_PORT +  M3_MAX_LAN_PORT + M3_MAX_HSSDC_PORT + M3_MAX_SHORTWAVE_FIBER_PORT + M3_MAX_BIG_UC +  M3_MAX_VOLTAGE + M3_MAX_TEMPERATURE + M3_MAX_OPERATING_LED + M3_MAX_CURRENT)

#define M3_DISPLAY_STRING_LENGTH 256
#define M3_CORE_DUMP_LENGTH 1024
#define M3_NUM_XBAR_PORTS 16
#define M3_SERIAL_MTU 1024
#define M3_WEB_PASSWORD_LENGTH 32

#define M3_MONITOR_STATE 0xff
#define M3_SELF_TEST_STATE 2
#define M3_OVER_TEMP_STATE 3
#define M3_DEAD_STATE 4
#define M3_OPERATING_STATE 5
#define M3_SHUTDOWN_STATE 6

enum
{
  M3_BACKPLANE_3 = 2,
  M3_BACKPLANE_5 = 4,
  M3_BACKPLANE_8 = 8,
  M3_BACKPLANE_17 = 16
};

enum
{
  M3_VOLTAGE_33 = 1,
  M3_VOLTAGE_66 = 2,
  M3_VOLTAGE_132 = 3
};

#define M3_OID "1.3.6.1.4.1.1771.3"
#define M3_TRAP_MASK_TABLE_OID "1.3.6.1.4.1.1771.3.1.2"
#define M3_TABLE_POSITION 9

enum
{
  M3_switchTrapCountForTrap = 1,
  M3_slotIDForTrap,
  M3_counter32ForTrap,
  M3_partIDForTrap,
  M3_counter64ForTrap
};

enum
{
  M3_ucResetTrap = 1,
  M3_ucFirmwareFaultTrap = 2,
  M3_ucOvertemperatureShutdownFaultTrap = 3,
  M3_slotLostCommunicationTrap = 4,
  M3_slotReestablishCommunicationTrap = 5,
  M3_slotChangedTrap = 6,
  M3_ucDeadTrap = 7,
  M3_fanBadTrap = 8,
  M3_fanTrayMissingTrap = 9,
  M3_fanTrayReinstalledTrap = 10,
  M3_acBadTrap = 11,
  M3_acGoodTrap = 12,
  M3_dcBadTrap = 13,
  M3_dcGoodTrap = 14,
  M3_badCrcTrap = 15,
  M3_invalidRouteTrap = 16,
  M3_illegalSymbolTrap = 17,
  M3_missedBeatTrap = 18,
  M3_deadPortTrap = 19,
  M3_portDownOnIllegalTrap = 20,
  M3_portDownOnMissedBeatTrap = 21,
  M3_portUpTrap = 22,
  M3_receiveTimeoutTrap = 23,
  M3_transmitTimeoutTrap = 24,
  M3_portSelftestTrap = 25,
  M3_sanFaultTrap = 26,
  M3_serdesFaultTrap = 27,
  M3_notInSyncTrap = 28,
  M3_overrunTrap = 29,
  M3_signalLostTrap = 30,
  M3_bigUcTrap = 31,
  M3_portDownForLanPortTrap = 32,
  M3_noCableTrap = 33,
  M3_NUM_TRAPS = 33
};


enum
{
  M3_TABLE_LENGTH_TABLE = 1,
  M3_TRAP_MASK_TABLE = 2,
  M3_PART_TABLE = 3,
  M3_UC_TABLE = 4,
  M3_LINECARD_TABLE = 5,
  M3_BACKPLANE_TABLE = 6,
  M3_BACKPLANE_MASTER_TABLE = 7,
  M3_FAN_TABLE = 8,
  M3_POWER_SUPPLY_TABLE = 9,
  M3_XBAR16_TABLE = 10,
  M3_XBAR_PORT_TABLE = 11,
  M3_SAN_PORT_TABLE = 12,
  M3_LAN_PORT_TABLE = 13,
  M3_HSSDC_PORT_TABLE = 14,
  M3_SHORTWAVE_FIBER_PORT_TABLE = 15,
  M3_BIG_UC_TABLE = 16,
  M3_VOLTAGE_TABLE = 17,
  M3_TEMPERATURE_TABLE = 18,
  M3_OPERATING_LED_TABLE = 19,
  M3_CORE_DUMP_TABLE = 20,
  M3_SLOT_TABLE = 21,
  M3_CURRENT_TABLE = 22,
  M3_GE_PORT_TABLE = 23,
  M3_NUM_TABLES = 23
};

#define M3_TRAP_QUEUE_SIZE 100
#define M3_TRAP_TIMEOUT 1000 /*milliseconds*/
#define M3_TRAP_SEND_NEXT_USECS 1000
#define M3_TRAP_PORT 162
#define M3_MAX_TRAP_VARIABLES 6
#define M3_BIG_UC_SLOT 56

#define M3_controlForXbarPort_format "1.3.6.1.4.1.1771.3.1.11.1.21.%d"
#define M3_controlForHssdcPort_format "1.3.6.1.4.1.1771.3.1.14.1.10.%d"
#define M3_controlForShortwaveFiberPort_format "1.3.6.1.4.1.1771.3.1.15.1.12.%d"
#define M3_xbar16Timeout_format "1.3.6.1.4.1.1771.3.1.10.1.4.%d"
#define M3_xbar16SelfTestResult_format "1.3.6.1.4.1.1771.3.1.10.1.5.%d"

/*1-based*/

#define M3_trapMask_enableColumn 2
#define M3_uc_rebootColumn 13
#define M3_linecard_shutdownColumn 4
#define M3_backplane_shutdownColumn 2
#define M3_backplaneMaster_shutdownColumn 4
#define M3_xbar16_timeoutColumn 4
#define M3_xbarPort_controlColumn 21
#define M3_hssdcPort_controlColumn 10
#define M3_gePort_controlColumn 4
#define M3_shortwaveFiberPort_controlColumn 12
#define M3_operatingLed_forceLedColumn 3
#define M3_lanPort_controlColumn 13

#define M3_bigUc_commandColumn 17
#define M3_bigUc_primaryEthernetPortIsActiveColumn 7
#define M3_bigUc_hostTrapCountColumn 11
#define M3_bigUc_trapTimeoutColumn 12
#define M3_bigUc_trapIpAddressColumn 15
#define M3_bigUc_communityColumn 16
#define M3_bigUc_trapSmtpServerColumn 20
#define M3_bigUc_trapMailAddressColumn 21
#define M3_bigUc_trapMailPeriodColumn 22

#define M3_COMMUNITY "public"
#define M3_HP_COMMUNITY "hp_hyperfabric_switch"

enum
{
  M3_TEST_GET_VERSION_STRING = 0,
  M3_TEST_REBOOT, 
  M3_TEST_GET_UPTIME,
  M3_TEST_GET_EXTENDED_COUNT,
  M3_TEST_GET_EXTENDED_VALUE,
  M3_TEST_GET_ETHERNET_ADDRESS,
  M3_TEST_SET_ACTIVE_ETHERNET_PORT,
  M3_TEST_GET_ACTIVE_ETHERNET_PORT,
  M3_TEST_SERIAL,
  M3_TEST_DEBUG,
  M3_TEST_STOP_UPDATE,
  M3_TEST_START_UPDATE,
  M3_TEST_LINK,
  M3_TEST_SET_NOTIFY,
  M3_TEST_SET_WEB_PASSWORD,
  M3_TEST_DISABLE_TASK,
  M3_TEST_GET_PACKET_COUNTS,
  M3_TEST_STREAM,
  M3_TEST_NUM_COMMANDS /*leave at end*/
};

#define M3_SNMP_USECS (1 * 1000 * 1000)
#define M3_IDLE_ETHERNET_USECS (1000 * 1000 * 2)
#define M3_BUSY_ETHERNET_USECS (1000 * 100)
#define M3_RARP_USECS (1000 * 1000 * 1)

#define M3_TEST_VERSION_STRING_LENGTH 200

typedef int m3_int;
typedef struct m3_int64
{
  m3_int high;
  m3_int low;
} m3_int64;


typedef struct m3_test_message_t
{
  m3_int type;
  m3_int xbar;
} m3_test_message_t;

typedef struct m3_test_int_message_t
{
  m3_test_message_t tp;
  m3_int integer;
} m3_test_int_message_t;

typedef struct m3_test_version_string_message_t
{
  m3_test_message_t tp;
  char version [M3_TEST_VERSION_STRING_LENGTH + 1];
} m3_test_version_string_message_t;

typedef struct m3_test_web_password_message_t
{
  m3_test_message_t tp;
  char username [M3_WEB_PASSWORD_LENGTH];
  char password [M3_WEB_PASSWORD_LENGTH];
} m3_test_web_password_message_t;

typedef struct m3_test_disable_task_message_t
{
  m3_test_message_t tp;
  char taskname [M3_DISPLAY_STRING_LENGTH];
} m3_test_disable_task_message_t;

typedef struct m3_test_ethernet_address_message_t
{
  m3_test_message_t tp;
  char address [6];
} m3_test_ethernet_address_message_t;

typedef struct m3_test_packet_counters_message_t
{
  m3_test_message_t tp;
  m3_int numPorts;
  m3_int pad;
  m3_int64 good [M3_MAX_XBAR_PORT];
  m3_int64 bad [M3_MAX_XBAR_PORT];
} m3_test_packet_counters_message_t;


typedef struct m3_test_serial_message_t
{
  m3_test_message_t tp;
  m3_int result;
  m3_int port;
  m3_int command;
  m3_int txlen;
  m3_int rxlen;
  m3_int num_commands;
  char payload [M3_TEST_MTU - sizeof (m3_test_message_t) - sizeof (m3_int) * 6];
} m3_test_serial_message_t;

typedef struct m3_serial_command_t
{
  int command;
  int port;
  int txlen;
  int rxlen;
  char*txbuf;
  char*rxbuf;
  int result;
}m3_serial_command_t;

typedef struct m3_test_link_header_t
{
  m3_test_message_t tp;
  m3_int mtu;
  m3_int received;
  m3_int stop;
} m3_test_link_header_t;

typedef struct m3_test_link_message_t
{
  m3_test_link_header_t header;
  char payload [M3_TEST_MTU - sizeof (m3_test_link_header_t)];
} m3_test_link_message_t;

typedef struct m3_test_set_notify_message_t
{
  m3_test_message_t tp;
  char ip_address [4]; /*ok to leave blank*/
  m3_int port;
  m3_int types[2];
} m3_test_set_notify_message_t;


typedef struct m3_notify_message_t
{
  m3_int type;
  char ethernet_address [6];
  char padding [2];
  m3_int slot;
  m3_int low;
  m3_int high;
  m3_int index;
  m3_int partType;
} m3_notify_message_t;

enum
{
  M3_ROLLCALL_QUERY,
  M3_ROLLCALL_REPLY,
  M3_ROLLCALL_OK
};

typedef struct m3_rollcall_message_t
{
  m3_int type;
  m3_int instance;
} m3_rollcall_message_t;

extern char*m3_trap_names [M3_NUM_TRAPS];

#define M3_NUM_TRAP_VARIABLES 5
extern char*m3_trap_variables [M3_NUM_TRAP_VARIABLES];
extern char*m3_table_names [M3_NUM_TABLES];

#ifdef m3_define_trap_names
char*m3_trap_names [M3_NUM_TRAPS] =
{
  "ucResetTrap",
  "ucFirmwareFaultTrap",
  "ucOvertemperatureShutdownFaultTrap",
  "slotLostCommunicationTrap",
  "slotReestablishCommunicationTrap",
  "slotChangedTrap",
  "ucDeadTrap",
  "fanBadTrap",
  "fanTrayMissingTrap",
  "fanTrayReinstalledTrap",
  "acBadTrap",
  "acGoodTrap",
  "dcBadTrap",
  "dcGoodTrap",
  "badCrcTrap",
  "invalidRouteTrap",
  "illegalSymbolTrap",
  "missedBeatTrap",
  "deadPortTrap",
  "portDownOnIllegalTrap",
  "portDownOnMissedBeatTrap",
  "portUpTrap",
  "receiveTimeoutTrap",
  "transmitTimeoutTrap",
  "portSelftestTrap",
  "sanFaultTrap",
  "serdesFaultTrap",
  "notInSyncTrap",
  "overrunTrap",
  "signalLostTrap",
  "bigUcBootTrap",
  "portDownForLanPortCount",
  "noCableTrap"
};

char*m3_trap_variables [M3_NUM_TRAP_VARIABLES] =
{
  "switchTrapCount",
  "slotID",
  "counter32",
  "partID",
  "counter64"
};

char*m3_table_names [M3_NUM_TABLES] =
{
  "TableLength",
  "TrapMask",
  "Part",
  "Uc",
  "Linecard",
  "Backplane",
  "BackplaneMaster",
  "Fan",
  "PowerSupply",
  "Xbar16",
  "XbarPort",
  "SanPort",
  "LanPort",
  "HssdcPort",
  "ShortwaveFiberPort",
  "BigUc",
  "Voltage",
  "Temperature",
  "OperatingLed",
  "CoreDump",
  "Slot",
  "Current",
  "GEPort"
};

#undef m3_define_trap_names
#endif

#ifdef m3_sparc_solaris
#define socklen_t int
#endif

#endif /*m3_defines_h*/
