/*
  stream_port.c
  example program to s
  finucane@myri.com (David Finucane)
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "m3_SerialClient.h"
#include "m3_defines.h"

static void printLine (char*s)
{
  printf ("%s\n", s);
}

int main (int argc, char**argv)
{
  m3_Component::initialize (printLine);
  m3_SerialClient client (argv[1]);
  int size = atoi (argv[2]);
  int num_commands = atoi (argv[3]);
  
  char*txbuf = (char*) malloc (size * num_commands);
  char*rxbuf = (char*) malloc (size * num_commands);
  m3_serial_command_t*commands = (m3_serial_command_t*) malloc (sizeof (m3_serial_command_t) * num_commands);
  
  for (int i = 0; i < num_commands; i++)
  {
    commands [i].command = 1;
    commands [i].port = 0;
    commands [i].txlen = size;
    commands [i].rxlen = size;
    commands [i].txbuf = txbuf + i * size;
    commands [i].rxbuf = rxbuf + i * size;
    commands [i].result = 0;
  }

  if (!client.run (num_commands, commands))
  {
    printf ("client.run failed\n");
    exit (0);
  }
  

  for (int i = 0; i < num_commands; i++)
  {
    printf ("result %d is %d\n", i, commands [i].result);
  }
  
  return 1;
}
