/*
cd /ufs/wind/finucane/m3/user/
make host
gcc  -g -O2  -DINSIST -DGCC -I../snmpv1/h -I../snmp++/include -x c++ -c -g -o intel_linux/switch_test.o switch_test.c
gcc  -o intel_linux/switch_test intel_linux/switch_test.o intel_linux/libhost.a -lm ../snmp++/src/libsnmp++.a

Compilation finished at Wed Jan 24 16:59:36
*/

#include <stdlib.h>
#include <stdio.h>
#include "m3_SwitchTest.h"
#include "m3_Hex2Uc.h"

#define die() {printf ("died on %s:%d\n", __FILE__, __LINE__); exit (1);}

static void printLine (char*s)
{
  printf ("%s\n", s);
}

m3_SwitchTestPort ports [m3_SwitchTest::MAX_PORTS];
m3_SwitchTestVoltage voltages [m3_SwitchTest::MAX_VOLTAGES];
m3_SwitchTestTemperature temperatures [m3_SwitchTest::MAX_TEMPERATURES];
m3_SwitchTestCurrent currents [m3_SwitchTest::MAX_CURRENTS];

int main (int argc, char*argv [])
{
  m3_Component::initialize (printLine);
  m3_SwitchTest switchTest (1, "hawking0");
  m3_Hex2Uc hex2uc;
  
  if (!switchTest.getPortCounts (0, 1, 1, 15, ports))
    die ();

  int slot = 1;
  int switch0 = 0;
  int switch1 = 1;
  int refreshes, refreshes2;
  int voltageA, voltageB;
  
  if (!(refreshes = switchTest.getRefreshes (switch0)))
    die ();

  printf ("refreshes is %d\n", refreshes);

  do 
  {
    if (!switchTest.getPortCounts (switch0, slot, 16, 8, &ports [8]))
      die ();
  }
  while ((refreshes2 = switchTest.getRefreshes (switch0)) == refreshes);

  printf ("refreshes2 is %d\n", refreshes2);

  if (!switchTest.getLineCardVoltages (switch0, 1, (unsigned*)&voltageA, (unsigned*)&voltageB))
    die ();
  printf ("voltageA is %d and voltageB is %d\n", voltageA, voltageB);
  
  if (!switchTest.setPortControl (switch0, 1, 9, 4))
    die ();

  if (!switchTest.setXbarTimeout (switch0, 1, 4000))
    die ();

  if (!switchTest.getVoltages (switch0, 1, 4, voltages))
    die ();

  if (!switchTest.getTemperatures (switch0, 2, 2, temperatures))
    die ();

  if (!switchTest.getCurrents (switch0, 1, 1, currents))
    die ();

  printf ("current is %d and overcurrentFault is %d\n", currents [0].current, currents [0].overcurrentFault);

  printf ("self test result is %d\n", switchTest.getXbarSelfTestResult (switch0, 1));
  
#if 0
  if (!hex2uc.program ("alpha0", "some.alan.file.hex", 0))
    die (); 
#endif
  
}
