/*
  uc_port.c
  program to talk to switch ucs test port
  finucane@myri.com (David Finucane)
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "m3_TestClient.h"
#include "m3_defines.h"

int make_number (char*p)
{
  int n;
  sscanf (p, "%i", &n);
  return n;
}

static void printLine (char*s)
{
  printf ("%s\n", s);
}

static void usage (char*s)
{
  if (s)
    printf ("unknown option %s\n", s);
  
  printf ("usage:\n");
  printf ("uc_port <host> <port> <command> <rxlen> <txbytes>\n");
  exit (1);
}

static char txbuf [1000];
static char rxbuf [1000];



int main (int argc, char**argv)
{
  m3_Component::initialize (printLine);

  if (argc < 5)
    usage (0);

  m3_TestClient client (argv [1]);
  
  int result = 0;
  int port = make_number (argv [2]);
  int command = make_number (argv [3]);
  int rxlen = make_number (argv [4]);
  int txlen = 0;
  
  for (int i = 5; i < argc; i++)
    txbuf [txlen++] = make_number (argv [i]);

  printf ("txlen is %d\n", txlen);
  client.printBuffer (txbuf, txlen);
  
  if (!client.serial (&result, port, command, txlen, txbuf, rxlen, rxbuf))
    return 0;
  
  printf ("\nresult is %d\n", result);
  client.printBuffer (rxbuf, rxlen);

  printf ("\n");
  return 1;
}
