/*
  web_port.c
  finucane@myri.com (David Finucane)
*/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

#include "m3_WebClient.h"
#include "m3_defines.h"

static void printLine (char*s)
{
  printf ("%s\n", s);
}

static void usage ()
{
  printf ("usage: web_port <switchname> <url>\n");
  exit (1);
}

int main (int argc, char**argv)
{
  m3_Component::initialize (printLine);
  m3_WebClient web;
  char*s;
  
  if (argc != 3)
    usage ();

  if (!(s = web.get (argv[1], argv[2])))
    return 1;

  while (s = web.token ())
    printf ("%s\n", s);
  return 0;
}

